<?php

function sm_create_menu(){

    //creates admin menu for snakemember!!
    add_menu_page("SnakeMember", "SnakeMember" , "manage_options", "snakemember" , "sm_admin_main_options", plugins_url("images/logo.png", dirname(__FILE__) ) );
    
    add_submenu_page("snakemember", "General Options", "General Options" , "manage_options", "snakemember" , "sm_admin_main_options"  );
    
    //call register settings function
  	add_action( 'admin_init', 'wp_sm_register_settings' );
    
}

function wp_sm_register_settings(){
    register_setting( 'wp-sm', 'sm_api' );
  	register_setting( 'wp-sm', 'sm_api_key' );
    register_setting( 'wp-sm', 'sm_funnel_id' );
    register_setting( 'wp-sm', 'sm_product_id' );
    register_setting( 'wp-sm', 'sm_promo_nicename' );
  	register_setting( 'wp-sm', 'sm_s3_api_key' );
    register_setting( 'wp-sm', 'sm_s3_api_secret' );
    register_setting( 'wp-sm', 'sm_prot_redir_url' );
    register_setting( 'wp-sm', 'sm_prot_redir' );
}

function sm_admin_main_options(){
  include(realpath(dirname(__FILE__)).'/main_options_view.php');
}


function sm_meta_boxes(){
  if (wp_sm_prot_use_redirect()){
    add_meta_box( 'sm-page-protected-redirect', 'SnakeMember Configure redirect', 'sm_protected_page_redirect_box', 'page', 'normal', 'high' );
  }
}

function sm_protected_page_redirect_box( $post ){
  //echo json_encode($post)
  //die();
  //echo $post->post_type;
  $values = get_post_custom( $post->ID );
  //wp_nonce_field( 'sm_meta_box_nonce', 'sm_meta_box' );
  $val = isset( $values['sm_custom_redirect'] ) ? $values['sm_custom_redirect'][0] : '';
  $protectd = wp_sm_object_is_protected( $post->ID , 'page')
  
?> 
<p> 
  <label for="sm_custom_redirect"><?php _e('Use custom URL to redirect', 'wp-sm') ?>:</label>
  <input type="text" name="sm_custom_redirect" id="sm_custom_redirect" value="<?php echo $val ?>" style="width:50%; min-width: 250px;" placeholder="Default URL: <?php echo wp_sm_prot_use_redirect(); ?>">  
</p>
<p><em><?php _e('Leave it Empty if you want to use default.', 'wp-sm') ?></em></p> 
<?php 
  if (!$protected) :
    ?>
    <p><em><?php _e('NB: This page isnt protected!', 'wp-sm') ?></em></p>
  <?php
  endif;
}

add_action( 'save_post', 'sm_protected_page_redirect_box_save' );

function sm_protected_page_redirect_box_save( $post_id )
{
    // Bail if we're doing an auto save
    if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;

    // if our nonce isn't there, or we can't verify it, bail
    //if( !isset( $_POST['sm_meta_box'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'sm_meta_box' ) ) return;

    // if our current user can't edit this post, bail
    if( !current_user_can( 'edit_post' ) ) return;

    // Probably a good idea to make sure your data is set

    if( isset( $_POST['sm_custom_redirect'] ) && trim($_POST['sm_custom_redirect']) != "" ){
      update_post_meta( $post_id, 'sm_custom_redirect', $_POST['sm_custom_redirect'] );
    }

}

add_action("admin_menu" , "sm_create_menu");

add_action( 'add_meta_boxes', 'sm_meta_boxes' );