<?php

// Register a URL that will set this variable to true
function wp_sm_rest_api_init() {
    add_rewrite_rule( '^wp_sm_rest_api$', 'index.php?wp_sm_rest_api=true', 'top' );
}

// But WordPress has a whitelist of variables it allows, so we must put it on that list
function wp_sm_rest_api_query_vars( $query_vars )
{
    $query_vars[] = 'wp_sm_rest_api';
    return $query_vars;
}

// If this is done, we can access it later
// This example checks very early in the process:
// if the variable is set, we include our page and stop execution after it
function wp_sm_rest_api_parse_request( &$wp )
{
    if ( array_key_exists( 'wp_sm_rest_api', $wp->query_vars ) ) {
        include( realpath(dirname( __FILE__ ) ) . '/sm_api_functions.php' );
        exit();
    }
}