<?php

//LIBRARY FUNCTIONS 
function unparse_url($parsed_url) { 
  $scheme   = isset($parsed_url['scheme']) ? $parsed_url['scheme'] . '://' : ''; 
  //echo "HOST " . $parsed_url['path'];
  //echo "FIRST 2: " . substr($parsed_url['host'], 0, 2);
  
  if ($scheme == '' && substr($parsed_url['host'], 0, 2) != '//' && substr($parsed_url['path'], 0, 2) != '//' ){
  	$scheme = 'http://';
  }
  
  $host     = isset($parsed_url['host']) ? $parsed_url['host'] : ''; 
  $port     = isset($parsed_url['port']) ? ':' . $parsed_url['port'] : ''; 
  $user     = isset($parsed_url['user']) ? $parsed_url['user'] : ''; 
  $pass     = isset($parsed_url['pass']) ? ':' . $parsed_url['pass']  : ''; 
  $pass     = ($user || $pass) ? "$pass@" : ''; 
  $path     = isset($parsed_url['path']) ? $parsed_url['path'] : ''; 
  $query    = isset($parsed_url['query']) ? '?' . $parsed_url['query'] : ''; 
  $fragment = isset($parsed_url['fragment']) ? '#' . $parsed_url['fragment'] : ''; 
  return "$scheme$user$pass$host$port$path$query$fragment"; 
} 

function sm_random_string($num_chars = 10)
{
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $randstring = '';
    for ($i = 0; $i < $num_chars; $i++) {
        $randstring .= $characters[rand(0, strlen($characters))];
    }
    return $randstring;
}

	$srcIframe = "http://www.areamembri.it/webforms/iframe/test?a=aaa&b=bbb";


function sm_iframe_url_with_params($srcIframe, $include_random = false){
	$arr_url = parse_url($srcIframe);

	//echo "QUERY: " . $arr_url["query"];
	$get_array = array();
	parse_str($arr_url["query"], $get_array);
	

	if ( get_aff_id('')!= '' && (!isset($get_array["aff_id"]) || $get_array["aff_id"] == '')){
		$get_array["aff_id"] = get_aff_id('');
	}
	if ( get_camp_id('') != '' && (!isset($get_array["camp_id"]) || $get_array["camp_id"] == '')) {
		$get_array["camp_id"] = get_camp_id('');
	}

	if (!empty($_GET)) {
        foreach ($_GET as $key => $value) {
            if (strpos($key, 'utm_') === 0 && !isset($get_array[$key])) { 
                // Aggiungi solo se inizia con "utm_" e non è già presente
                $get_array[$key] = $value;
            }
        }
    }
	
	if ($include_random){
		$random_var_name = sm_random_string(10);
		while (isset($get_array[$random_var_name])){
			$random_var_name = sm_random_string(10);
		}
		$get_array[$random_var_name] = sm_random_string(10);
	}
	//var_dump($get_array);
	//Reassemble

	$arr_url["query"] = http_build_query($get_array);
	$srcIframe = unparse_url($arr_url);
	//echo "FINAL: " . $srcIframe;
	return $srcIframe;
}

//END LIBRARY FUNCTIONS 


// Offers Links ShortCode 

function sm_offer_link_function($atts){
	$atts = shortcode_atts( array(
			'product' => ''
	), $atts, 'sm_offer_link' );

	$product_nicename = $atts['product'];
	$link = "#";
	if (!is_null($product_nicename)){
		$base_link = "https://www.areamembri.it/products/" . $product_nicename . "/confirm" ;
		if ($_REQUEST["offers"] && $_REQUEST["offers"][$product_nicename]){
			$link = $base_link . "/" . $_REQUEST["offers"][$product_nicename];
		}
		else {
			$link = $base_link;
		}
	}
	return $link;
}


add_shortcode('sm_offer_link', 'sm_offer_link_function');



	function sm_webform_iframe_creation($atts) {
		$atts = shortcode_atts( array(
			'id' => '',
			'src' => null
		), $atts, 'sm_webform_iframe' );

		if(!is_null($atts['src'])) {
			$srcIframe = $atts['src'];
			$srcIframe = sm_iframe_url_with_params($srcIframe, true); //true for No caching .. 
		} else {
			$srcIframe = "https://snakemember.areamembri.it/webforms/iframe/".$atts['id'];
			$srcIframe = sm_iframe_url_with_params($srcIframe, false); // false: SM already implements no caching
		}
		
		$html = "<script src='https://areamembri.s3.amazonaws.com/assets/jquery-iframe-resizer/iframeResizer.js' type='text/javascript'></script>
		<style>.responsive-multi-iframe{width:100%;}</style>
		<iframe id='".$atts['id']."' class='responsive-multi-iframe' src='".$srcIframe."' frameborder='0' scrolling='no'></iframe>"; 
		
		$html .= <<<EOD
<script type='text/javascript'>
	jQuery(document).ready(function(){

		iFrameResize({log:false, heightCalculationMethod: 'max'}, '.responsive-multi-iframe');

		function getQueryParams(qs) {
		    qs = qs.split('+').join(' ');

		    var params = {},
		        tokens,
		        re = /[?&]?([^=]+)=([^&]*)/g;

		    while (tokens = re.exec(qs)) {
		        params[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
		    }

		    return params;
		}
		

		function getUtmParams(params) {
		    return Object.keys(params).reduce((acc, key) => {
		        if (key.startsWith('utm_')) {
		            acc[key] = params[key];
		        }
		        return acc;
		    }, {});
		}

		function sendUtmParams(iframe, utmParams) {
			var iframeDomain;
		    try {
		        iframeDomain = new URL(iframe.src).origin; // Estrae protocollo + dominio + porta
		    } catch (e) {

		    	try{
		    		iframeDomain = new URL(iframe.getAttribute("data-src")).origin
		    	}
		    	catch(e){
		    		console.error("Errore nell'estrazione del dominio dell'iframe:", e);
		    	}

		        
		    }
	        if (iframe.contentWindow && iframeDomain) {
	        	
	            iframe.contentWindow.postMessage({utmParams}, iframeDomain);
	        }
	    }

		var iframe = document.querySelector('.responsive-multi-iframe');

		if (iframe) {
		    var sm_query = getQueryParams(document.location.search);
		    var utmParams = getUtmParams(sm_query);

		    sendUtmParams(iframe, utmParams);
		    iframe.onload = function () {
		        sendUtmParams(iframe, utmParams);
		    };
		}


	});
</script>
EOD; 

		
		return $html;
	}

	add_shortcode('sm_webform_iframe', 'sm_webform_iframe_creation');

	function sm_add_tinymce_plugin($plugin_array) {

	    $plugin_array['sm_webform'] = plugins_url('assets/js/shortcodes.js', __FILE__ );
	    return $plugin_array;
	}

	function sm_add_tinymce_button($buttons) {

	    array_push( $buttons, 'sm_webform_button' );
	    return $buttons;
	}

	function sm_add_tinymce() {
	    global $typenow;

	    if( ! in_array( $typenow, array( 'post', 'page' ) ) )
	        return;

	    add_filter( 'mce_external_plugins', 'sm_add_tinymce_plugin' );
	    add_filter( 'mce_buttons', 'sm_add_tinymce_button' );
	}

	add_action( 'admin_head', 'sm_add_tinymce' );

	function get_json_sm_webforms() {
		$_webForms = get_sm_webforms();
		$data = array();
		foreach($_webForms as $webforms){
			if($webforms->webforms) {
				foreach($webforms->webforms as $webform) {
					$data[] = array(
						'text' => 'List ['.$webforms->campaign_description.']: '. $webform->webform_name,
						'value' => $webform->webform_nicename,
					);
				}
			}
		}
		wp_send_json($data);
	}

	function get_json_sm_webforms_ajax() {
		check_ajax_referer('sm-webforms-nonce', 'security');
		return get_json_sm_webforms();
	}

	add_action( 'wp_ajax_sm_webforms_ajax', 'get_json_sm_webforms_ajax');

	function sm_webforms_ajax() {
		// create nonce
		global $pagenow;
		$nonce = wp_create_nonce('sm-webforms-nonce');
		?><script type="text/javascript">
			jQuery( document ).ready( function( $ ) {
				var data = {
					'action'	: 'sm_webforms_ajax',
					'security'	: '<?php echo $nonce; ?>'
				};
			  	jQuery.post( ajaxurl, data, function(response) {
			  		if(response === '-1') {
				  		console.log('error');
			  		} else {
			  			if (typeof(tinyMCE) != 'undefined') {
			  				if (tinyMCE.activeEditor != null) {			  					
								tinyMCE.activeEditor.settings.smWebformsList = response;
							}
						}
			  		}
			  	});
			});
		</script>
	<?php 
	}
	
	add_action('admin_footer', 'sm_webforms_ajax');
?>