<?php
class SnakeMember_WebForms_Widget extends WP_Widget {

	function __construct() {
		parent::__construct(
			'SnakeMember_WebForms_Widget',
			__('SnakeMember WebForms iFrame', 'sm_webforms_iframe'), 
			array('description' => __('SnakeMember WebForms iFrame generator', 'sm_webforms_iframe'),) 
		);
	}

	public function widget( $args, $instance ) {

		if ( array_key_exists('before_widget', $args) ) echo $args['before_widget'];
		
		echo do_shortcode('[sm_webform_iframe id="'.$instance['nicename_webform'].'"]');
			
		if ( array_key_exists('after_widget', $args) ) echo $args['after_widget'];
	}

	public function form( $instance ) {
		
		if ( isset( $instance['nicename_webform'] ) ) {
			$webformId = $instance['nicename_webform'];
		}
		else {
			$webformId = 0;
		}
		?>
		
		<p>
			<?php _e('You can add a Snake Member webform to show on the sidebar. You can customize your webform on Snake Member'); ?><br/><br/>
			<label for="<?php echo $this->get_field_id('nicename_webform'); ?>"><?php _e('Select the webform'); ?>:</label> 
			
			<select id="<?php echo $this->get_field_id('nicename_webform'); ?>" name="<?php echo $this->get_field_name('nicename_webform'); ?>">
				<option value="0"><?php _e('Please, choose an option...'); ?></option> 
				<?php 
				$_webForms = get_sm_webforms();

				if($_webForms && is_array($_webForms) && count($_webForms) > 0){
					foreach($_webForms as $webforms){
						if($webforms->webforms) {
							echo "<optgroup label='". $webforms->campaign_description ."'>";
							foreach($webforms->webforms as $webform) {
								$selected = false;
								if($webform->webform_nicename == $webformId) {
									$selected = true;
								}
								echo "<option value='".$webform->webform_nicename."'";
								if($selected){
									echo " selected='selected' ";
								} 
								echo ">". $webform->webform_name ."</option>";
							}
							echo "</optgroup>";
						}
					}
				}							
			?>
			</select>
		</p>
		<?php 
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['nicename_webform'] = ( ! empty( $new_instance['nicename_webform'] ) ) ? strip_tags( $new_instance['nicename_webform'] ) : '';
		return $instance;
	}
}

add_action( 'widgets_init', function(){
     register_widget( 'SnakeMember_WebForms_Widget' );
});	

add_filter('widget_text', 'do_shortcode');