<?php
	// Display Fields
	add_action('woocommerce_product_options_general_product_data', 'sm_woo_product_add_listname');
	// Save Fields
	add_action('woocommerce_process_product_meta', 'sm_woo_product_save_listname');
	// Order Placed
	add_action('woocommerce_checkout_order_processed', 'sm_woo_order_placed');
	// Order complete
	add_action('woocommerce_order_status_completed', 'sm_woo_order_completed');

	function sm_woo_product_add_listname() 
	{
		global $woocommerce, $post;
		$lists = get_snake_lists_custom();

		echo '<div class="options_group">';
	
		?>
		<p class="form-field product_field_type">
		<label for="listname_order_placed"><?php _e('SM List - Order Placed', 'wp-sm'); ?></label>
		<select id="listname_order_placed" name="listname_order_placed" class="select short" data-placeholder="<?php _e('Search for a list', 'wp-sm'); ?>">
			<?php				
				if(count($lists) > 0) {
					$currentList = get_post_meta($post->ID, 'listname_order_placed', true);
					
					echo '<option value="null">';
						_e('Search for a list', 'wp-sm');
					echo '</option>';

					foreach ($lists as $list) {
						echo '<option value="' . $list['nicename'] . '"';
						if($list['nicename'] == $currentList) {
							echo ' selected="selected" ';
						}
						echo '>' . $list['name'] . '</option>';
					}
				}
			?>
		</select> <img class="help_tip" data-tip='<?php _e('Choose a list to which the customer is going to be subscribed when he buys this product and order is created.', 'wp-sm') ?>' src="<?php echo $woocommerce->plugin_url(); ?>/assets/images/help.png" height="16" width="16" />
		</p>

		<p class="form-field product_field_type">
		<label for="listname_order_complete"><?php _e('SM List - Order Complete', 'wp-sm'); ?></label>
		<select id="listname_order_complete" name="listname_order_complete" class="select short" data-placeholder="<?php _e('Search for a list', 'wp-sm'); ?>">
			<?php
				if(count($lists) > 0) {
					$currentList = get_post_meta($post->ID, 'listname_order_complete', true);
					
					echo '<option value="null">';
						_e('Search for a list', 'wp-sm');
					echo '</option>';

					foreach ($lists as $list) {
						echo '<option value="' . $list['nicename'] . '"';
						if($list['nicename'] == $currentList) {
							echo ' selected="selected" ';
						}
						echo '>' . $list['name'] . '</option>';
					}
				}
			?>
		</select> <img class="help_tip" data-tip='<?php _e('Choose a list to which the customer is going to be subscribed when he buys this product and order is completed.', 'wp-sm') ?>' src="<?php echo $woocommerce->plugin_url(); ?>/assets/images/help.png" height="16" width="16" />
		</p>
		<?php

		echo '</div>';
	}

	function sm_woo_product_save_listname($postId)
	{
		$listOrderPlaced 	=  $_POST['listname_order_placed'];
		$listOrderComplete 	=  $_POST['listname_order_complete'];
		$lists = get_snake_lists_custom();

		if(in_array($listOrderPlaced, $lists) || $listOrderPlaced == 0) {
			update_post_meta($postId, 'listname_order_placed', $listOrderPlaced);
		}
		if(in_array($listOrderComplete, $lists) || $listOrderComplete == 0) {
			update_post_meta($postId, 'listname_order_complete', $listOrderComplete);
		}
	}

	function sm_woo_order_available_status()
	{
		return array('complete', 'placed');
	}

	function sm_woo_order_check($orderId = null, $status = null) 
	{
		if(	$orderId <= 0 || 
			!in_array($status, sm_woo_order_available_status())
		) {
			return false;
		} 

		$order = wc_get_order($orderId);
		$items = $order->get_items();
		$userId = $order->user_id;
		$customer = get_userdata($userId);

		$customerData = array();
		$customerData['email'] 	= ($customer->user_email) ? $customer->user_email : null;
		$customerData['name'] 	= ($customer->first_name) ? $customer->first_name : null;
		$customerData['last_name'] = ($customer->last_name) ? $customer->last_name : null;

		foreach ($items as $item) {
			$product = $order->get_product_from_item($item);
			$productId = $product->id;

			$listnameOrder = get_post_meta($productId, 'listname_order_'.$status, true);
		
			if($listnameOrder != "") {
				sm_woo_subscribe($listnameOrder, $customerData);
			}
		}
	}

	function sm_woo_order_placed($orderId) 
	{
		sm_woo_order_check($orderId, 'placed');
	}

	function sm_woo_order_completed($orderId) 
	{		
		sm_woo_order_check($orderId, 'complete');
	}

	function sm_woo_subscribe($listname = "", $customer = null)
	{
		if($listname == "" && $listnameOrder != "null") {
			return;
		}

		$result = optin($listname, $customer);
	}

	
?>